function []=image_pre_stage(directory,token,position,set)
% this file will filter all the images in a dicrectory
% it will generate a folder call "filter" were will save the filter images
% YOU WILL HAVE TO CHANGE THE FILTER BY HAND TO ADJUST THE THRESHOLDING AND
% OTHER PARAMETERS. (only the ones with white brackground, and some red
% backgrounds)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%we load the name of all the images in file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

archivo=[directory '\' token '\' position '\' set '\*.bmp' ]; % solo lee las imagenes jpg

lista = dir(archivo); %lista donde se guarda el nombre de todas las imagenes 
                %en ese directorio       
                
dist=length(lista);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%we process each image
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%generate the folder to save all
mkdir(['filter\' token '\' position '\'], set)  ; 

for k = 1 : dist
    
  %we obtain the directory of the picture
  image = [directory '\' token '\' position '\' set '\' lista(k).name]; 
  
  %we filter the image (we have to choose the best filter)
  
  [final]=black_spots(image);
%   [final]=black_white_spots(image);
%   [final]=black_spots(image);

  %we save the image
  imwrite(final,fullfile(['filter\' token '\' position '\' set '\' ], lista(k).name));

end
end