function [stringfinal1]=gabor_hash(imagen,level,f0)

I=imagen;
%depending of the image type we have to do one pre-stage or not
if size(I,3)==3
I1=rgb2gray(I);
g0=im2double(I1);
else
g0=im2double(I);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%GAUSSIAN PYRAMID
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %level=4;%number of times we reduce the image 
 if level~=0 %if we dont want to reduce the image
for i=1:level
     [g1f]=separable_cubic_B_spline_filter(g0);
     [g1]=diezmado_media_ponderadac(g1f);
     clear g0
     g0=g1;
     clear g1
end
 end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%GABOR FILTERING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[imagen45,imagen135]=Filtros_gabor_duplicando_bordes(g0,f0);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%THRESHOLDING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[imagen45,imagen135]=thresholding(imagen45,imagen135);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%CONCATENATION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[stringfinal1]=concatenacion(imagen45,imagen135);
end