function [numero]=generate_reference_codewords(directory)
%the input is the name of the folder where we just have the reference
%images.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Secret key generation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%we generate a random code that will we our secre key "K". We generate a
%file with that name where we will save all.
%This secret key must be given with the token to the costumer
numero=round(rand()*100000000);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Find the images that will be our REFERENCE IMAGES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
archivo='\*.bmp'; % solo lee las imagenes jpg
a=[directory archivo];
lista = dir(a); %lista donde se guarda el nombre de todas las imagenes 
                %en ese directorio

longitud=length(lista);

% we load the images
for k = 1 : longitud
  imagen = imread(fullfile(directory, lista(k).name)); %leemos la imagen

%%%%%%%%%%%%%%%%%%%%%%%%%% Gabor Hash function %%%%%%%%%%%%%%%%%%%%%%%%%%%%
level=6; %parameter need for the Gabor function
f0=0.2;  %parameter need for the Gabor function
[stringfinal1]=gabor_hash(imagen,level,f0);
codewords=stringfinal1; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  codeword(k,:) = codewords; %we store the vector
end


nombre = num2str(numero); % we change from number to string so we can give 
                          % the folder the secret key name 
                                                    
%nombre = strcat(nombre, '.txt'); %to save in avery format wanted

save(nombre,'codeword','-double'); % we generate the folder with the secret
                                   % key name
end