function [imagen45,imagen135]=thresholding(imagen45,imagen135)

%Here we do the thresholding of the image.
%If the value of the pixel is <0 then the value is 0. 
%If the value fo the pixel is >=0 then the value is 1.
%im2bw makes thresholding between [0,1], the problem is that 0 is always 0,
%and here we need it to be 1. that is why we add 0.0001 to all the values.
%0.0001 is so low that doesnt affect the rest of the pixels, just the 0
%value pixels.

imagen45=im2bw(imagen45+0.0001,0);
imagen135=im2bw(imagen135+0.0001,0);

end